SystemOrganization addCategory: #'tODE-AmberDebugger'!

Object subclass: #TOADebugger
	instanceVariableNames: 'exception frames'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'tODE-AmberDebugger'!

!TOADebugger methodsFor: 'private' stamp: 'dkh 10/24/2011 15:11'!
createFrames
    | context frame next |
    frames := OrderedCollection new.
    context := exception signalerContext.
    frame := (TOAFrame new)
        initialContext: context;
        debugger: self;
        yourself.
    [ context isNil ]
        whileFalse: [ 
            frames add: frame.
            context := context sender.
            context
                ifNotNil: [ 
                    next := (TOAFrame new)
                        context: context;
                        debugger: self;
                        yourself.
                    frame next: next.
                    next previous: frame.
                    frame := next ] ]! !

!TOADebugger methodsFor: 'accessing' stamp: 'dkh 10/24/2011 09:40'!
exception
    ^exception! !

!TOADebugger methodsFor: 'accessing' stamp: 'dkh 10/24/2011 09:39'!
exception: anException
    exception := anException.
    self createFrames! !

!TOADebugger methodsFor: 'accessing' stamp: 'dkh 10/24/2011 09:40'!
frames
    ^frames! !

!TOADebugger methodsFor: 'accessing' stamp: 'dkh 10/24/2011 11:32'!
tODEAmberRendererClass
    false
        ifTrue: [ ^ super tODEAmberRendererClass ].
    ^ TOAmberDebuggerRenderer! !

Object subclass: #TOAFrame
	instanceVariableNames: 'debugger previous next method context receiver pcRange'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'tODE-AmberDebugger'!

!TOAFrame methodsFor: 'accessing' stamp: 'dkh 10/24/2011 09:54'!
context

	^context! !

!TOAFrame methodsFor: 'accessing' stamp: 'dkh 10/24/2011 15:09'!
context: aMethodContext

	context := aMethodContext.
	receiver := context receiver.
	method := MethodReference class: context method classBinding value selector: context method selector.
	pcRange := context debuggerMap rangeForPC: context pc contextIsActiveContext: false.! !

!TOAFrame methodsFor: 'accessing' stamp: 'dkh 10/24/2011 09:40'!
debugger: aTOADebugger

	debugger := aTOADebugger! !

!TOAFrame methodsFor: 'accessing' stamp: 'dkh 10/24/2011 15:16'!
initialContext: aMethodContext
    context := aMethodContext.
    receiver := context receiver.
    method := MethodReference class: context method classBinding value selector: context method selector.
    pcRange := context debuggerMap rangeForPC: context pc contextIsActiveContext: true! !

!TOAFrame methodsFor: 'accessing' stamp: 'dkh 10/24/2011 12:01'!
method
    ^ method! !

!TOAFrame methodsFor: 'accessing' stamp: 'dkh 10/24/2011 09:49'!
next: aTOAFrame

	next := aTOAFrame! !

!TOAFrame methodsFor: 'accessing' stamp: 'dkh 10/24/2011 15:12'!
pcRange

	^pcRange! !

!TOAFrame methodsFor: 'accessing' stamp: 'dkh 10/24/2011 15:04'!
previous

	^previous! !

!TOAFrame methodsFor: 'accessing' stamp: 'dkh 10/24/2011 09:50'!
previous: aTOAFrame

	previous := aTOAFrame! !

!TOAFrame methodsFor: 'printing' stamp: 'dkh 10/24/2011 09:53'!
printContext: aContext on: aStream
	| outerContext |
	(outerContext := aContext outerContext)
		ifNil: [aContext  printOn: aStream]
		ifNotNil:
			[
			 aStream nextPutAll: ' [] in '.
			 self printContext: outerContext on: aStream]! !

!TOAFrame methodsFor: 'printing' stamp: 'dkh 10/24/2011 09:54'!
printOn: aStream
	self printContext: self context on: aStream! !

!TOAFrame methodsFor: 'accessing' stamp: 'dkh 10/24/2011 12:02'!
receiver
    ^ receiver! !

!TOAFrame methodsFor: 'printing' stamp: 'dkh 10/24/2011 15:57'!
renderJsonContext: aContext nested: aStream on: json
    | outerContext |
    (outerContext := aContext outerContext)
        ifNil: [ 
            | range |
            "perhaps it would be cool to navigate to the outer contexts from here?"
            json key: 'active' value: false.
            json key: 'nesting' value: aStream contents.
            json key: 'receiverClass' value: aContext receiver class name asString.
            json key: 'methodClass' value: aContext method classBinding value name asString.
            json key: 'selector' value: aContext method selector asString.
            json key: 'methodSource' value: self method sourceString withUnixLineEndings.
            json key: 'srcFrom' value: self pcRange first.
            json key: 'srcTo' value: pcRange last.
            json key: 'sourceArea' value: nil ]
        ifNotNil: [ 
            aStream nextPutAll: ' [] in '.
            self renderJsonContext: outerContext nested: aStream on: json ]! !

!TOAFrame methodsFor: 'printing' stamp: 'dkh 10/24/2011 13:35'!
renderJsonOn: json
    self renderJsonContext: self context nested: (WriteStream on: String new) on: json
! !

!TOAmberErrorHandler methodsFor: '*tode-amberdebugger' stamp: 'dkh 10/24/2011 15:15'!
open: anException
    | renderer |
    [ 
    false
        ifTrue: [ super open: anException ].
    renderer := (TOAmberFrameComponent new)
        object:
                ((TOADebugger new)
                        exception: anException;
                        yourself);
        target: '_blank';
        yourself.
    self session presenter object: anException.
    self session presenter call: renderer onAnswer: [ self halt ] ] on: Error do: [ :ex | super open: ex ]! !

TOAmberAbstractRenderer subclass: #TOAmberDebuggerRenderer
	instanceVariableNames: ''
	classVariableNames: 'TOASourceArea'
	poolDictionaries: ''
	category: 'tODE-AmberDebugger'!

!TOAmberDebuggerRenderer methodsFor: 'rendering' stamp: 'dkh 10/24/2011 17:26'!
renderBlockMethod
    "[:frame :object :html :main | ...]"

    ^ [ :frame :obj :html :main | 
    (html span)
        style: 'color: red; font-weight: bold; font-size: xx-large';
        with: obj state heading.
    obj state frames
        do: [ :stkFrame | 
            | rClass mClass |
            (html div)
                id: stkFrame id;
                with: [ 
                            html div
                                with: [ 
                                    html a
                                        with: [ 
                                            (html span)
                                                style: 'font-size: x-small';
                                                with: stkFrame nesting.
                                            (html span)
                                                style: 'font-size: x-small; font-weight: bold';
                                                with: (rClass := stkFrame receiverClass).
                                            rClass ~= (mClass := stkFrame methodClass)
                                                ifTrue: [ 
                                                    (html span)
                                                        style: 'font-size: x-small';
                                                        with: '(' , mClass , ')' ].
                                            html with: '>>'.
                                            (html span)
                                                style: 'font-size: x-small; font-weight: bold';
                                                with: stkFrame selector ] ].
                            html div
                                with: [ 
                                    stkFrame sourceArea
                                        ifNil: [ 
                                            | sourceArea |
                                            sourceArea := TOASourceArea new.
                                            sourceArea source: stkFrame methodSource.
                                            sourceArea renderOn: html.	"sourceArea refresh.
                                            sourceArea
                                                selectionStart: stkFrame srcFrom;
                                                selectionEnd: stkFrame srcTo."
                                            stkFrame sourceArea: sourceArea ] ] ].
            html script
                with:
                    '$( ''#' , stkFrame id asString , ''').accordion({collapsible: true, fillSpace: false, active: '
                        , stkFrame active asString , ', autoHeight: false});' ] ]! !

!TOAmberDebuggerRenderer methodsFor: 'rendering' stamp: 'dkh 10/24/2011 14:04'!
renderContentOn: json
    json
        object: [ 
            json key: 'heading' value: self object exception description.
            json
                key: 'frames'
                value: [ 
                    json
                        array: [ 
                            | frameId |
                            frameId := 0.
                            self object frames
                                do: [ :frame | 
                                    json
                                        value: [ 
                                            json
                                                object: [ 
                                                    json key: 'id' value: frameId.
                                                    frame renderJsonOn: json.
                                                    frameId := frameId + 1 ] ] ] ] ] ]! !
